package org.bitbucket.bradleysmithllc.etlunit.feature.database;

import org.bitbucket.bradleysmithllc.etlunit.feature.file.RequestedFmlNotFoundException;
import org.bitbucket.bradleysmithllc.etlunit.io.file.DataFileSchema;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestValueObject;

import java.io.File;
import java.io.IOException;

public interface DatabaseRuntimeSupport
{
	File getSourceDataDirectoryForCurrentTest();
	File getSourceScriptsDirectoryForCurrentTest();

	File getSourceDataDirectory(String package_);
	File getSourceScriptsDirectory(String package_);

	File getSourceDataSet(String package_, String dataSetName, String use);
	File getSourceDataSetForCurrentTest(String dataSetName, String use);

	File getSourceScript(String package_, String scriptName, String use);
	File getSourceScriptForCurrentTest(String scriptName, String use);


	File getCachedMetaData(DatabaseConnection conn);
	File getGeneratedSourceDirectory(DatabaseConnection conn, String mode);
	File getGeneratedDataSet(DatabaseConnection conn, String mode, String dataSetName);

	DataFileSchema createRelationalMetaInfo(DatabaseConnection dbConn, String schema, String name);
	DataFileSchema createRelationalMetaInfo(String connectionId, String schema, String name);

	DataFileSchema getRelationalMetaInfo(DatabaseConnection dbConn, String schema, String name, String masterName, ETLTestValueObject etlObj) throws RequestedFmlNotFoundException;
	DataFileSchema getRelationalMetaInfo(String connectionId, String schema, String name, String masterName, ETLTestValueObject etlObj) throws RequestedFmlNotFoundException;

	void persistDataFileSchema(DataFileSchema schema) throws IOException;
}