package org.bitbucket.bradleysmithllc.etlunit.feature.database;

import org.bitbucket.bradleysmithllc.etlunit.TestExecutionError;

import java.io.IOException;

public interface SQLAggregator
{
	interface DDLRef
	{
		String getRefName();
		int getLineNumber();
		String describe();
	}

	interface FileRef
	{
		DDLRef getBeginRef();
		DDLRef getEndRef();

		int getBeginAggregatedLineNumber();
		int getEndAggregatedLineNumber();

		int getBeginCleanLineNumber();
		int getEndCleanLineNumber();

		String getLine();

		String describe();
	}

	interface Aggregator
	{
		boolean hasNext();
		FileRef next();
	}

	interface SQLLocator
	{
		String locate(DDLSourceRef ref, DatabaseConnection connection) throws IOException, TestExecutionError;
	}

	/**
	 * Gets the clean text, without instrumentation.
	 * @return
	 */
	String getCleanText();

	String getText();
	Aggregator getLineAggregator();
	Aggregator getStatementAggregator();
}